void case_0(int lsb, float val)
{
  switch (lsb)
  {
    case 0:
#if 0
      {
        char inst[20];
        if (!val)
          val = 7;
        sprintf((char *)&inst, "I%d.ins", val);
        File frec = SD.open(inst, FILE_READ);
        if (frec)
        {
          Serial.println(inst);
          HarmInst.Restore(frec);
          ci = val - 1;
          for (int i = 0; i < MP[ci]; i++)
            HarmInst.attach(instrument[i]);
          frec.close();
        }
      }
#endif
      break;
    case 1:
      break;
  }
}

void case_1(int lsb, float val)
{
  switch (lsb)
  {
    case 0:
    case 1:
    case 2:
    case 3:
      //      mixer1.gain(lsb, fmap(val, 0, 127, 0, 1));
      break;
    case 4:
    case 5:
    case 6:
    case 7:
      //      mixer2.gain(lsb - 4, fmap(val, 0, 127, 0, 1));
      break;
    case 9:
      mixer3.gain(lsb - 8, fmap(val, 0, 127, 0, 1));
      break;
    case 8:
    case 10:
    case 11:
      mixer3.gain(lsb - 8, fmap(val, 0, 127, 0, 1));
      break;
    case 12:
    case 13:
    case 14:
    case 15:
      mixer4.gain(lsb - 12, fmap(val, 0, 127, 0, 1));
      break;
    case 16:
    case 17:
    case 18:
    case 19:
      mixer5.gain(lsb - 16, 1 - fmap(val, 0, 127, 0, 1));
      mixer5.gain(lsb - 15, fmap(val, 0, 127, 0, 1));
      break;
    case 20:
    case 21:
    case 22:
    case 23:
    case 24:
    case 25:
      break;
  }

}

void case_2(int lsb, float val)
{
  switch (lsb)
  {
    case 0:
    case 2:
      filter1.frequency(fmap(val, 0, 127, 0, 8000));
      //      filter2.frequency(fmap(val, 0, 127, 0, 8000));
      break;
    case 1:
    case 3:
      filter1.resonance(fmap(val, 0, 127, 0.7, 5));
      //      filter2.resonance(fmap(val, 0, 127, 0.7, 5));
      break;
    case 4:
      filter3.frequency(fmap(val, 0, 127, 0, 8000));
      break;
    case 5:
      filter3.resonance(fmap(val, 0, 127, 0.7, 5));
      break;
    default:
      break;
  }

}

void case_3(int lsb, float val)
{
  switch (lsb)
  {
    case 0:
    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
    case 6:
    case 7:
      BA_delayExt1.delay(lsb, fmap(val, 0, 127, 20, 1400));
      break;
  }

}

void case_4(int lsb, float val)
{
  switch (lsb)
  {
    case 0:
      HarmInst.setDuration(part, val, omni, mark, endmark);
      break;
    case 1:
      HarmInst.setAmp(part, fmap(val, 0, 127, 0, 1), omni, mark, endmark);
      break;
  }

}

void case_5(int lsb, float val)
{

  switch (lsb)
  {
    case 0:
      sine1.frequency(fmap(val, 0, 127, 0, 5));
      break;
    case 1:
      sine1.amplitude(fmap(val, 0, 127, 0, 1));
      break;
  }
}

void case_6(int lsb, float val)
{
  int delta = endmark - mark + 1;
  Partial *cpart = HarmInst.partials[(int)val];
  Partial *spart;
  if (debug)
  {
    Serial.print("mark = ");
    Serial.println(mark);
    Serial.print("endmark = ");
    Serial.println(endmark);
    Serial.print(" -> ");
    Serial.print(delta);
    Serial.print("=");
    Serial.print(endmark);
    Serial.print(" - ");
    Serial.println(mark);
  }
  switch (lsb)
  {
    case 0:
      mark = val;
      sourcepart = part;
      break;
    case 1:
      endmark = val;
      break;
    case 3:
      target = val;
      break;
    case 4:
      part = val;
      if (debug)
      {
        Serial.print("copy from ");
        Serial.print(sourcepart);
        Serial.print(",");
        Serial.print(mark);
        Serial.print(" : ");
        Serial.print(endmark);
        Serial.print(" -> ");
        Serial.print(part);
        Serial.print(",");
        Serial.println(target);
      }
      spart = HarmInst.partials[(int)sourcepart];
      for (int i = mark; i <= endmark; i++)
      {
        cpart->levels[target + i - mark] = spart->levels[ i ];
        cpart->amps[target + i - mark] = spart->amps[ i ];
        cpart->times[target + i - mark] = spart->times[ i ];
      }
      HarmInst.activate();

      break;
    case 5:
      part = val;
      spart = HarmInst.partials[(int)sourcepart];
      if (debug)
      {
        Serial.print("move from ");
        Serial.print(sourcepart);
        Serial.print(",");
        Serial.print(mark);
        Serial.print(" : ");
        Serial.print(endmark);
        Serial.print(" -> ");
        Serial.print(part);
        Serial.print(",");
        Serial.println(target);
      }
      for (int i = mark; i <= endmark; i++)
      {
        cpart->levels[target + i - mark] = spart->levels[ i ];
        cpart->amps[target + i - mark] = spart->amps[ i ];
        cpart->times[target + i - mark] = spart->times[ i ];
      }

      for (int i = mark; i < spart->numseg - delta; i++)
      {
        spart->levels[ i ] = spart->levels[ i + delta];
        spart->amps[ i ] = spart->amps[ i + delta];
        spart->times[ i ] = spart->times[ i + delta];
      }
      spart->numseg -= delta;
      HarmInst.activate();
      break;
    case 6:
      part = val;
      if (mark > -1 && endmark > mark)
      {
        if (debug)
        {
          Serial.print("delete from ");
          Serial.print(part);
          Serial.print(",");
          Serial.print(mark);
          Serial.print(" + ");
          Serial.print(delta);
          Serial.print(" ~ ");
          Serial.print(cpart->numseg);
          Serial.print(" : ");
          Serial.println(endmark);
        }
        for (int i = mark; i < cpart->numseg; i++)
        {
          float old = cpart->levels[i];
          float newv = cpart->levels[i + delta];
          cpart->levels[i] = newv;
          old = cpart->amps[i];
          newv = cpart->amps[i + delta];
          cpart->amps[i] = newv;
          old = cpart->times[i];
          newv = cpart->times[i + delta];
          cpart->times[i] = newv;

        }
        cpart->numseg -= delta;;
      }
      HarmInst.activate();
      break;
    case 7:
      mark = -1;
      endmark = -1;
      target = -1;
      break;
    case 17:
      mark = -1;
      break;
    case 8:
      debug = !debug;
      if (debug)
        Serial.println("debug is on");
      break;
    case 9:
      // part = val;
      if (debug)
      {
        Serial.print("insert into ");
        Serial.print(target);
        Serial.print(",");
        Serial.print(mark);
        Serial.print(" : ");
        Serial.print(delta);
        Serial.print(" ");
        Serial.print( cpart->numseg);
        Serial.print(" ");
        Serial.println(endmark);
      }
      if (mark > -1 && endmark > mark)
      {
        Partial *cpart = HarmInst.partials[part];
        int oldns = cpart->numseg;
        cpart->numseg += delta;
        for (int i = cpart->numseg - 1; i >= target && i - delta >= 0; i--)
        {
          cpart->levels[i] =  cpart->levels[i - delta];
          cpart->amps[i] =  cpart->amps[i - delta];
          cpart->times[i] =  cpart->times[i - delta];
        }
      }
      break;
    case 10:        //  10  omni  set loop point from mark to endmark
      HarmInst.m_harm_fm->loopmark = mark;
      HarmInst.m_harm_fm->loopend = endmark;
      break;
  }
  if (debug)
  {
    Serial.print(delta);
    Serial.print("=");
    Serial.print(endmark);
    Serial.print(" - ");
    Serial.println(mark);
  }
  if (debug)
  {
    Serial.print("mark = ");
    Serial.println(mark);
    Serial.print("endmark = ");
    Serial.println(endmark);
  }
}

void case_7(int lsb, float val)
{
  switch (lsb)
  {
    case 0:
      click = val;
      break;
  }

}

void case_11(int lsb, float val)
{
  switch (lsb)
  {
    case 0:
      omni = false;
      if (val) part = val - 1;
      else omni = true;
      if (debug)
      {
        Serial.print("omni ");
        Serial.println(omni);
      }
      break;
    case 1:
      switch ((int)val)
      {
        case 0:
          spread = false;
          break;
        case 1:
          reset(segment, segment + 16, part);
          break;
        case 2:
          if (debug)
          {
            Serial.print(omni);
            Serial.print(" reset ");
            Serial.println(part);
          }
          if (mark > -1 && endmark > mark)
            resetsel();
          else if (!omni)
            reset(0, -1, part);
          else
          {
            for (int p = 0; p < HarmInst.numharm; p++)
              reset(0, -1, p);
          }
          break;
        case  3:
          spread = true;
          break;
        case  4:
          spread = false;
          break;
        case  6:
          HarmInst.setnumharm(part + 1);
          break;
        case 7:
          {
            int ms = segment + 16;
            if (mark > -1)
              ms = mark;
            HarmInst.setnumseg(ms);
          }
          break;
        case 8:
          if (!omni)
            reverse(part);
          else
          {
            for (int p = 0; p < HarmInst.numharm; p++)
              reverse( p);
          }
          HarmInst.activate();
          break;
        case 9:
          for (int p = 0; p < HarmInst.numharm; p++)
            reset(0, -1, p);
          break;
      }
      break;
    case 2:
      segment = val * 16;
      break;
    case 3:
      HarmInst.setnumseg(val);
      break;
    case 4:
      HarmInst.setnumharm(val);
      if (debug)
      {
        Serial.print("numharm: ");
        Serial.println(val);
      }
      break;
  }

}
void case_13(int lsb, float val)
{
  HarmInst.setOffset(lsb, val / 10);
  //        Serial.print("seto ");
  //        Serial.println(lsb);

}
void case_14(int lsb, float val)
{
  HarmInst.setPhase(lsb, val);
  //        Serial.print("setp ");
  //        Serial.println(lsb);

}
void case_15(int lsb, float val)
{
  HarmInst.setnumseg(val, lsb);

  //        Serial.print("setp ");
  //        Serial.println(lsb);

}
void case_16(int lsb, float val)
{
  if (lsb == 64)
  {
    HarmInst.activate();
  }
}

void case_17(int lsb, float val)
{

  HarmInst.m_harm_fm->setsolo(lsb, val > 0);

}
void case_18(int lsb, float val)
{
  HarmInst.m_harm_fm->setmute(lsb, val > 0);
}

